/*********************************************************************************
 * This file is part of package Dynamic Panels.
 * 
 * Author : Variance InfoTech PVT LTD (http://www.varianceinfotech.com)
 * All rights (c) 2021 by Variance InfoTech PVT LTD
 *
 * This Version of Dynamic Panels is licensed software and may only be used in 
 * alignment with the License Agreement received with this Software.
 * This Software is copyrighted and may not be further distributed without
 * written consent of Variance InfoTech PVT LTD
 * 
 * You can contact via email at info@varianceinfotech.com
 * 
 ********************************************************************************/
//default panels and fields hide
$.ajax({
    url: "index.php?entryPoint=VIDynamicPanelsDefault",
    type: "post",
    data: {module : moduleName,
          actionName : actionName},
    dataType : "JSON",
    success: function (response) {
        var defaultFieldsHide = response['defaultFieldsHide'];
        var viewTabsHide = response['viewTabsHide'];
        var viewPanelsHide = response['viewPanelsHide'];
        var defaultReadonlyFieldsArray = response['defaultReadonlyFieldsArray'];

        //default fields hide
        dynamicPanelsFieldShowHide(defaultFieldsHide,'hide');
            
        //default tabs hide
        viewTabsHide = jQuery.parseJSON(viewTabsHide);
        dynamicPanelsTabsShowHide(viewTabsHide,'hide');
        
        //default panels hide
        viewPanelsHide = jQuery.parseJSON(viewPanelsHide);
        dynamicPanelsShowHide(viewPanelsHide,'hide');
        
        dynamicPanelsTabsPanelsShowHide(viewPanelsHide,viewTabsHide,'hide');

        //default readonly
        readOnlyArray(defaultReadonlyFieldsArray);
    }//end of success
});//end of ajax

$.ajax({
        url: "index.php?entryPoint=VIDynamicPanelsDetailViewCheckCondition",
        type: "post",
        data: {module : moduleName,
              recordId : recordId},
        dataType : "JSON",
        success: function(result) {
            $.each(result,function(index,data){
                var detailViewTabsHide = data['detailViewTabsHide'];
                var detailViewPanelsHide = data['detailViewPanelsHide']; 
                var detailViewTabsShow = data['detailViewTabsShow'];
                var detailViewPanelsShow = data['detailViewPanelsShow']; 
                var fieldsShow = data['fieldsShowArray'];
                var fieldsHide = data['fieldsHideArray'];
                var fieldsColorArray = data['fieldColorrArray'];
                var fieldsReadOnlyArray = data['fieldsReadOnlyArray'];
               
                //tabs Hide
                detailViewTabsHide = jQuery.parseJSON(detailViewTabsHide);
                dynamicPanelsTabsShowHide(detailViewTabsHide,'hide');

                //panels Hide
                detailViewPanelsHide = jQuery.parseJSON(detailViewPanelsHide);
                dynamicPanelsShowHide(detailViewPanelsHide,'hide');
                
                dynamicPanelsTabsPanelsShowHide(detailViewPanelsHide,detailViewTabsHide,'hide');
                
                //tabs show
                detailViewTabsShow = jQuery.parseJSON(detailViewTabsShow);
                dynamicPanelsTabsShowHide(detailViewTabsShow,'show');
                
                //panels show
                detailViewPanelsShow = jQuery.parseJSON(detailViewPanelsShow);
                dynamicPanelsShowHide(detailViewPanelsShow,'show');
                 
                dynamicPanelsTabsPanelsShowHide(detailViewPanelsShow,detailViewTabsShow,'show');
                
                //fields show
                dynamicPanelsFieldShowHide(fieldsShow,'show');
                
                //fields hide
                dynamicPanelsFieldShowHide(fieldsHide,'show');
                
                //fields color
                $.each(fieldsColorArray, function (index, value) {
                    var find = "_address_";
                    var val = value.fieldName;
                    if(val.indexOf(find) != -1){
                        $('#'+val).closest('div').css('background','#'+value.fieldColor);
                    }else{
                        if(moduleName == 'Spots'){
                            $("#"+val).css('background','#'+value.fieldColor);
                        }else{
                            $("div[field='"+val+"']").css('background','#'+value.fieldColor);
                        }//end of else
                    }//end of else
                });//end of each

                //field readonly    
                readOnlyArray(fieldsReadOnlyArray);
            });//end of each
        }//end of success
});//end of ajax

function readOnlyArray(fieldsReadOnlyArray){
    $.each(fieldsReadOnlyArray, function (index, value) {
        var find = "_address_";
        var val = value['field'];
        if(val.indexOf(find) != -1){
            $('#'+val).closest('div').css('pointer-events','none');
        }else{
            $("div[field='"+value['field']+"']").css('pointer-events','none');
        }//end of else
    });//end of each
}//end of function

function dynamicPanelsFieldShowHide(fields,type){
    $.each(fields, function (index, value) {
        var find = "_address_";
        if(value.indexOf(find) != -1){
            if(type == 'hide'){
                $('#'+value).closest('div').hide();
                $('#'+value).closest('div').parent().hide();
            }else{
                $('#'+value).closest('div').show();
                $('#'+value).closest('div').parent().show();
            }//end of else
        }else{
            if(type == 'hide'){
                $("div[field='"+value+"']").parent().hide();
            }else{
                $("div[field='"+value+"']").parent().show();
            }//end of else    
        }//end of else
    });//end of function
}//end of function

function dynamicPanelsTabsShowHide(allTabs,type){
    $('ul.nav-tabs > li > a[data-toggle=tab]').each(function(){
        var panelName = $.trim($(this).text());
        var tabId = $(this).attr("id");
        if(jQuery.inArray(panelName,allTabs) != '-1'){
            if(type == 'hide'){
                $('ul.nav-tabs > li > a[id='+tabId+']').parent().hide();
            }else{
                $('ul.nav-tabs > li > a[id='+tabId+']').parent().show();
            }//end of else
            
            var arr = tabId.substr(-1);
            if(type == 'hide'){
                $('div[id=tab-content-'+arr+']').hide();
            }else{
                $('div[id=tab-content-'+arr+']').show();
            }//end of else
        }//end of if
    });//end of each

    $('div .panel-heading').each(function(){
        var panels = $.trim($(this).closest('div').text());
        if(jQuery.inArray(panels,allTabs) != '-1'){
            if(type == 'hide'){
                $(this).closest('div').parent().hide();
            }else{
                $(this).closest('div').parent().show();
            }//end of else
        }//end of if
    });//end of each
}//end of function

function dynamicPanelsShowHide(allPanels,type){
    $('div .panel-heading').each(function(){
        var panels = $.trim($(this).closest('div').text());
        if(jQuery.inArray(panels,allPanels) != '-1'){
            if(type == 'hide'){
                $(this).closest('div').parent().hide();
            }else{
                $(this).closest('div').parent().show();
            }//end of else
        }//end of if
    });//end of each

    $('ul.nav-tabs > li > a[data-toggle=tab]').each(function(){
        var panelName = $.trim($(this).text());
        var tabId = $(this).attr("id");
        if(jQuery.inArray(panelName,allPanels) != '-1'){
            if(type == 'hide'){
                $('ul.nav-tabs > li > a[id='+tabId+']').parent().hide();
            }else{
                $('ul.nav-tabs > li > a[id='+tabId+']').parent().show();
            }//end of else
            var arr = tabId.substr(-1);;
            if(type == 'hide'){
                $('div[id=tab-content-'+arr+']').hide();
            }else{
                $('div[id=tab-content-'+arr+']').show();
            }//end of else
        }//end of if
    });//end of each
}//end of function

function dynamicPanelsTabsPanelsShowHide(allPanels,allTabs,type){
    $('ul.nav-tabs > li > a[data-toggle=tab]').each(function(){
        var panelName = $.trim($(this).text());
        var tabId = $(this).attr("id");
        $('body').on('click','ul.nav-tabs > li > a[id='+tabId+']',function(){
            var arr = tabId.substr(-1);
            $('div .panel-heading').each(function(){
                var panels = $.trim($(this).closest('div').text());
                var tabPanelId = $.trim($(this).parent('div').attr('class').substr(-1));
                if(arr == tabPanelId){
                    if(jQuery.inArray(panels,allPanels) != '-1'){
                        if(type == 'hide'){
                            $(this).closest('div').parent().hide();
                        }else{
                            $(this).closest('div').parent().show();
                        }//end of else
                    }//end of if 
                }//end of if
            });//end of each

            if(jQuery.inArray(panelName,allPanels) != '-1'){
                if(type == 'hide'){
                    $('ul.nav-tabs > li > a[id='+tabId+']').parent().hide();
                }else{
                    $('ul.nav-tabs > li > a[id='+tabId+']').parent().show();
                }//end of else
                var arr = tabId.substr(-1);
                if(type == 'hide'){
                    $('div[id=tab-content-'+arr+']').hide();
                }else{
                    $('div[id=tab-content-'+arr+']').show();
                }//end of else
            }//end of if

            if(jQuery.inArray(panelName,allTabs) != '-1'){
                if(type == 'hide'){
                    $('ul.nav-tabs > li > a[id='+tabId+']').parent().hide();
                }else{
                    $('ul.nav-tabs > li > a[id='+tabId+']').parent().show();
                }//end of else
                var arr = tabId.substr(-1);
                if(type == 'hide'){
                    $('div[id=tab-content-'+arr+']').hide();
                }else{
                    $('div[id=tab-content-'+arr+']').show();
                }//end of else
            }//end of if

            $('div .panel-heading').each(function(){
                var panels = $.trim($(this).closest('div').text());
                var tabPanelId = $.trim($(this).parent('div').attr('class').substr(-1));
                if(arr == tabPanelId){
                    if(jQuery.inArray(panels,allTabs) != '-1'){
                        if(type == 'hide'){
                            $(this).closest('div').parent().hide();
                        }else{
                            $(this).closest('div').parent().show();
                        }//end of else
                    }//end of if 
                }//end of if
            });//end of each
        });//end of each
    });//end of each
}//end of function